"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.array.is-array.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.array.from.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/web.timers.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
var _FormBuilder = _interopRequireDefault(require("./FormBuilder"));
var _powerAssert = _interopRequireDefault(require("power-assert"));
var _harness = _interopRequireDefault(require("../test/harness"));
var _simpleWizard = _interopRequireDefault(require("../test/forms/simpleWizard"));
var _formWithFormController = _interopRequireDefault(require("../test/forms/formWithFormController"));
var _utils = require("./utils/utils");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) { n[e] = r[e]; } return n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
global.requestAnimationFrame = function (cb) {
  return cb();
};
global.cancelAnimationFrame = function () {};
describe('WizardBuilder tests', function () {
  var formBuilderElement, formBuilder;
  after(function (done) {
    destroyWizardBuilder();
    done();
  });
  function destroyWizardBuilder() {
    if (formBuilder && formBuilder.instance) {
      formBuilder.instance.destroy();
      document.body.removeChild(formBuilderElement);
    }
  }
  function createWizardBuilder() {
    var form = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      display: 'wizard',
      components: []
    };
    destroyWizardBuilder();
    formBuilderElement = document.createElement('div');
    document.body.appendChild(formBuilderElement);
    formBuilder = new _FormBuilder["default"](formBuilderElement, _objectSpread(_objectSpread({}, form), {}, {
      components: _toConsumableArray(form.components)
    }), {});
    return formBuilder;
  }
  it('Test page remove with cancellation', function (done) {
    var builder = createWizardBuilder(_simpleWizard["default"]);
    setTimeout(function () {
      var panel = builder.instance.webform.components[0];
      var removeComponentRef = panel.refs.removeComponent;
      window.confirm = function () {
        return false;
      };
      _harness["default"].clickElement(panel, removeComponentRef);
      setTimeout(function () {
        _powerAssert["default"].equal(builder.instance._form.components.length, 5, 'Should not remove the page on cancel');
        _powerAssert["default"].equal(builder.instance.webform.components[0].key, 'page1', 'Should stay on page 1 since we' + ' canceled the deletion');
        done();
      }, 300);
    }, 500);
  });
  it('Test page remove with confirmation', function (done) {
    var builder = createWizardBuilder(_simpleWizard["default"]);
    setTimeout(function () {
      var panel = builder.instance.webform.components[0];
      var removeComponentRef = panel.refs.removeComponent;
      window.confirm = function () {
        return true;
      };
      _harness["default"].clickElement(panel, removeComponentRef);
      setTimeout(function () {
        _powerAssert["default"].equal(builder.instance._form.components.length, 4, 'Should remove the page on confirm');
        _powerAssert["default"].equal(builder.instance.webform.components[0].key, 'page2', 'Should switch to the next page when' + ' deletion is confirmed');
        done();
      }, 300);
    }, 500);
  });
  it('Test page remove with confirmation when remove from component settings window', function (done) {
    var builder = createWizardBuilder(_simpleWizard["default"]);
    setTimeout(function () {
      var panel = builder.instance.webform.components[0];
      var editComponentRef = panel.refs.editComponent;
      window.confirm = function () {
        return true;
      };
      _harness["default"].clickElement(panel, editComponentRef);
      setTimeout(function () {
        (0, _powerAssert["default"])(builder.instance.editForm, 'Should create the settings form on component edit');
        var removeButton = builder.instance.componentEdit.querySelector('[ref="removeButton"]');
        _harness["default"].clickElement(panel, removeButton);
        setTimeout(function () {
          _powerAssert["default"].equal(builder.instance._form.components.length, 4, 'Should remove the page on confirm');
          _powerAssert["default"].equal(builder.instance.webform.components[0].key, 'page2', 'Should switch to the next page when' + ' deletion is confirmed');
          done();
        }, 300);
      }, 300);
    }, 500);
  });
  it('Should execute form controller', function (done) {
    var form = (0, _utils.fastCloneDeep)(_formWithFormController["default"]);
    form.display = 'wizard';
    var builder = createWizardBuilder(form).instance;
    setTimeout(function () {
      var textF = builder.webform.getComponent('textField');
      _powerAssert["default"].equal(textF.getValue(), 'Hello World');
      _powerAssert["default"].equal(textF.disabled, true);
      _powerAssert["default"].equal(builder.webform.components[0].disabled, true);
      done();
    }, 500);
  });
  it('Test pages reorder', function (done) {
    var builder = createWizardBuilder(_simpleWizard["default"]);
    setTimeout(function () {
      var drake = builder.instance.navigationDragula;
      var addPageBtn = builder.instance.element.querySelector('.wizard-add-page');
      _powerAssert["default"].equal(drake.canMove(addPageBtn), false, 'Should not be able to move Add Page button');
      var pagesElements = builder.instance.element.querySelectorAll('.wizard-pages li');
      _powerAssert["default"].equal(pagesElements.length, 6, 'Should contain all buttons for all the pages + Add Page button');
      var firstPage = pagesElements[0];
      _powerAssert["default"].equal(drake.canMove(firstPage), true, 'Should be able to move page button');
      done();
    }, 500);
  });
});