"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFormioUploadAdapterPlugin = void 0;
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
require("core-js/modules/es.promise.finally.js");
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.number.constructor.js");
var _utils = require("../../utils/utils");
var _nativePromiseOnly = _interopRequireDefault(require("native-promise-only"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * UploadAdapter for CKEditor https://ckeditor.com/docs/ckeditor5/latest/framework/guides/deep-dive/upload-adapter.html
 */
var FormioUploadAdapter = /*#__PURE__*/function () {
  function FormioUploadAdapter(loader, fileService, component) {
    _classCallCheck(this, FormioUploadAdapter);
    this.loader = loader;
    this.fileService = fileService;
    this.component = component;
  }
  _createClass(FormioUploadAdapter, [{
    key: "upload",
    value: function upload() {
      var _this = this;
      return this.loader.file.then(function (file) {
        return new _nativePromiseOnly["default"](function (resolve, reject) {
          var _this$fileService;
          var _this$component$compo = _this.component.component,
            uploadStorage = _this$component$compo.uploadStorage,
            uploadUrl = _this$component$compo.uploadUrl,
            uploadOptions = _this$component$compo.uploadOptions,
            uploadDir = _this$component$compo.uploadDir,
            fileKey = _this$component$compo.fileKey;
          var uploadParams = [uploadStorage, file, (0, _utils.uniqueName)(file.name), uploadDir || '',
          //should pass empty string if undefined
          function (evt) {
            return _this.onUploadProgress(evt);
          }, uploadUrl, uploadOptions, fileKey, null, null];
          var uploadPromise = (_this$fileService = _this.fileService).uploadFile.apply(_this$fileService, uploadParams.concat([function () {
            return _this.component.emit('fileUploadingStart', uploadPromise);
          }])).then(function (result) {
            return _this.fileService.downloadFile(result);
          }).then(function (result) {
            return resolve({
              "default": result.url
            });
          })["catch"](function (err) {
            console.warn('An Error occured while uploading file', err);
            reject(err);
          })["finally"](function () {
            _this.component.emit('fileUploadingEnd', uploadPromise);
          });
        });
      });
    }
  }, {
    key: "abort",
    value: function abort() {}
  }, {
    key: "onUploadProgress",
    value: function onUploadProgress(evt) {
      if (evt.lengthComputable) {
        this.loader.uploadTotal = evt.total;
        this.loader.uploaded = evt.loaded;
      }
    }
  }]);
  return FormioUploadAdapter;
}();
var getFormioUploadAdapterPlugin = function getFormioUploadAdapterPlugin(fileService, component) {
  return function (editor) {
    editor.plugins.get('FileRepository').createUploadAdapter = function (loader) {
      return new FormioUploadAdapter(loader, fileService, component);
    };
  };
};
exports.getFormioUploadAdapterPlugin = getFormioUploadAdapterPlugin;