"use strict";

require("core-js/modules/es.reflect.construct.js");
require("core-js/modules/es.object.create.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
require("core-js/modules/es.array.every.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.object.set-prototype-of.js");
require("core-js/modules/es.function.bind.js");
require("core-js/modules/es.object.get-prototype-of.js");
var _ConditionOperator2 = _interopRequireDefault(require("./ConditionOperator"));
var _lodash = _interopRequireDefault(require("lodash"));
var _utils = require("../utils");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _createSuper(t) { var r = _isNativeReflectConstruct(); return function () { var e, o = _getPrototypeOf(t); if (r) { var s = _getPrototypeOf(this).constructor; e = Reflect.construct(o, arguments, s); } else e = o.apply(this, arguments); return _possibleConstructorReturn(this, e); }; }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
var IsEqualTo = /*#__PURE__*/function (_ConditionOperator) {
  _inherits(IsEqualTo, _ConditionOperator);
  var _super = _createSuper(IsEqualTo);
  function IsEqualTo() {
    _classCallCheck(this, IsEqualTo);
    return _super.apply(this, arguments);
  }
  _createClass(IsEqualTo, [{
    key: "execute",
    value: function execute(_ref) {
      var value = _ref.value,
        comparedValue = _ref.comparedValue,
        instance = _ref.instance,
        conditionComponentPath = _ref.conditionComponentPath;
      if ((value || value === false) && comparedValue && _typeof(value) !== _typeof(comparedValue) && _lodash["default"].isString(comparedValue)) {
        try {
          comparedValue = JSON.parse(comparedValue);
        }
        // eslint-disable-next-line no-empty
        catch (e) {}
      }
      if (instance && instance.root) {
        var _conditionTriggerComp;
        var conditionTriggerComponent = instance.root.getComponent(conditionComponentPath);
        if (conditionTriggerComponent && (0, _utils.isSelectResourceWithObjectValue)(conditionTriggerComponent.component) && (_conditionTriggerComp = conditionTriggerComponent.component) !== null && _conditionTriggerComp !== void 0 && _conditionTriggerComp.template) {
          if (!value || !_lodash["default"].isPlainObject(value)) {
            return false;
          }
          var _conditionTriggerComp2 = conditionTriggerComponent.component,
            template = _conditionTriggerComp2.template,
            valueProperty = _conditionTriggerComp2.valueProperty;
          if (valueProperty === 'data') {
            value = {
              data: value
            };
            comparedValue = {
              data: comparedValue
            };
          }
          return _lodash["default"].every((0, _utils.getItemTemplateKeys)(template) || [], function (k) {
            return _lodash["default"].isEqual(_lodash["default"].get(value, k), _lodash["default"].get(comparedValue, k));
          });
        }
      }

      //special check for select boxes
      if (_lodash["default"].isObject(value) && comparedValue && _lodash["default"].isString(comparedValue)) {
        return value[comparedValue];
      }
      return _lodash["default"].isEqual(value, comparedValue);
    }
  }], [{
    key: "operatorKey",
    get: function get() {
      return 'isEqual';
    }
  }, {
    key: "displayedName",
    get: function get() {
      return 'Is Equal To';
    }
  }]);
  return IsEqualTo;
}(_ConditionOperator2["default"]);
exports["default"] = IsEqualTo;